//---------------------------------------------------------------------------
#ifndef AdvanceBarH
#define AdvanceBarH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
class PACKAGE TAdvanceBar : public TGraphicControl
{
private:
   TColor					FBarColor;	 		//Bar Color
   TColor					FBackColor;	 		//Back Color
   int						FPosition;	 		//Bar Position
   int						FOrientation; 		//Bar Orientation
   int						FMax;		 		//Maximum Value Pos/Max=Bar %
   bool						FTextured;

   void __fastcall SetBarColor(const TColor ABarColor);
   void __fastcall SetBackColor(const TColor ABackColor);
   void __fastcall SetPosition (int APosition);
   void __fastcall SetOrientation (int AOrientation);
   void __fastcall SetMax (int AMax);

protected:
   void __fastcall Paint(void);

   DYNAMIC void __fastcall MouseDown(TMouseButton Button,
		   TShiftState Shift, int X, int Y);
   DYNAMIC void __fastcall MouseUp(TMouseButton Button,
		   TShiftState Shift, int X, int Y);
   DYNAMIC void __fastcall MouseMove(TShiftState Shift, int X, int Y);
   TMouseEvent fOnMouseDown;
   TMouseEvent fOnMouseUp;
   TMouseMoveEvent fOnMouseMove;

public:
	__fastcall TAdvanceBar(TComponent* Owner);
   __fastcall ~TAdvanceBar();
   void __fastcall Inc(int Value);		// Increment Position by Value
   void __fastcall Dec(int Value);		// Decrement Position by value

__published:
   __property TColor BackColor={read=FBackColor, write=SetBackColor, default=clBlack};
   __property TColor BarColor={read=FBarColor, write=SetBarColor};
   __property int Max={read=FMax, write=SetMax};
   __property int Orientation={read=FOrientation, write=SetOrientation};
   __property int Position={read=FPosition, write=SetPosition};
//   __property OnClick;
   __property OnMouseDown={read=fOnMouseDown, write=fOnMouseDown};
   __property OnMouseUp={read=fOnMouseUp,     write=fOnMouseUp};
   __property OnMouseMove={read=fOnMouseMove, write=fOnMouseMove};
};
//---------------------------------------------------------------------------
#endif
