//---------------------------------------------------------------------------
// here the previously saved settings of the program are restored
//---------------------------------------------------------------------------

#include <vcl.h>
#include "pch.h"
#pragma  hdrstop

#include "LoadSettings.h"

void __fastcall TMainForm::LoadSettings(char *name)
{
   WinradStatus param;
   String  KeyName("Software\\digiRadio"), version;
   char    cfgname[128] = {"Config_"};
   bool    def, rc;

   TRegistry& SettingsReg = *(new TRegistry);
   SettingsReg.RootKey  = HKEY_CURRENT_USER;
   def = (*name == '*');

   if (SettingsReg.OpenKey(KeyName, false) &&
      (version = SettingsReg.ReadString("Version")) != VERSION)
   {
      SettingsReg.CloseKey();
      SettingsReg.DeleteKey(KeyName);
   }
   else
      SettingsReg.CloseKey();

   if (!SettingsReg.OpenKey(KeyName, false) || def)
   {
// if no previous settings, or error, load defaults
loaddef:

      srateIn    = DEFAULT_RATE;
      sampleRate = srateIn;
	  wintype    = nuttall;
      SP1Base->Position  = 29;
      SP1Gain->Position  = 36;
      WF1Gain->Position  = 233;
      WF1Speed->Position = 75;
	  SP2Base->Position  = 24;
	  SP2Gain->Position  = 34;
	  WF2Gain->Position  = 220;
	  WF2Speed->Position = 15;
	  AGCGain->Position  = 0;
	  activePalette      = Winrad;
	  agc                = slow;
	  driver             = WMME;
	  WF1ResPos          = 0;
	  CWWF2Resol         = 2;
	  SSBWF2Resol        = 0;
	  FMWF2Resol         = 0;
	  DRMWF2Resol        = 0;
	  datamode           = mIQ;
	  mode               = USB;
	  SSBFF2locut        = 150.;
	  SSBFF2hicut        = 3000.;
	  FMFF2locut         = 50.;
	  FMFF2hicut         = 11500.;
	  DRMFF2locut        = 50.;
	  DRMFF2hicut        = 11500.;
	  FF1freq            = 0.;
      CWPitch            = 700.;
      CWbw               = 400;
	  AvgWF1->ItemIndex  = 2;
      AvgWF2->ItemIndex  = 0;
      skew               = 0.;
      Qmult              = 1.;
      swapIQ             = false;
      Den2qfac           = 0.98;
      BlkThr             = 6.5;
      vol                = 40;
      wf1slow            = false;
      Den1fac            = 77.F;
      WF1Contrast->Position = 80;
      WF2Contrast->Position = 80;
      sp1fullspeed       = false;
      polyfactor         = 2;
      revWF1scroll       = true;
      wavdir             = ExtractFilePath(Application->ExeName);
	  WF1avg             = false;
      WF2avg             = true;
	  extLOfreq          = 0.;
	  extLOoffset 		 = 88300000;
	  ComboBox4->Text = String(extLOoffset / 1000);
	  wfm_deemph_tau	 = 5.e-5;
	  ComboBox1->Text = String(int(wfm_deemph_tau * 1.e6));
	  wfm_rf_cut		 = 25e4;
	  ComboBox2->Text = String(wfm_rf_cut / 1000);
	  wfm_audio_cut		 = 7e3;
	  ComboBox3->Text = String(wfm_audio_cut / 1000);
	  leftdly            = 0;
	  rightdly           = 0;
	  processPriority    = NORMAL_PRIORITY_CLASS;
	  vollocked          = false;
   }
   else
   {
	  if(*name == '$') strcpy(cfgname, name+1);
	  else             strcat(cfgname, name);

	  if(!SettingsReg.ReadBinaryData(cfgname, &param, sizeof(param)))
		goto loaddef;

	  srateIn      = param.srateIn;
	  sampleRate   = param.sampleRate;
	  wintype      = param.wintype;
	  SP1Base->Position  = param.BasePos1;
	  SP1Gain->Position  = param.GainPos1;
	  WF1Gain->Position  = param.WF1GainPos;
	  WF1Speed->Position = param.WF1SpeedPos;
	  SP2Base->Position  = param.BasePos2;
	  SP2Gain->Position  = param.GainPos2;
	  WF2Gain->Position  = param.WF2GainPos;
	  WF2Speed->Position = param.WF2SpeedPos;
	  AGCGain->Position  = param.AGCGainPos;
	  activePalette      = param.activePalette;
	  agc                = param.agc;
	  driver             = param.driver;
	  WF1ResPos          = param.WF1ResPos;
	  CWWF2Resol         = param.CWWF2Resol ;
	  SSBWF2Resol        = param.SSBWF2Resol;
	  FMWF2Resol         = param.FMWF2Resol;
	  DRMWF2Resol        = param.DRMWF2Resol;
	  datamode           = param.datamode;
	  mode               = param.mode;
	  SSBFF2locut        = param.SSBFF2locut;
	  SSBFF2hicut        = param.SSBFF2hicut;
	  FMFF2locut         = param.FMFF2locut;
	  FMFF2hicut         = param.FMFF2hicut;
	  DRMFF2locut        = param.DRMFF2locut;
	  DRMFF2hicut        = param.DRMFF2hicut;
	  FF1freq            = param.FF1freq;
	  CWPitch            = param.CWPitch;
	  CWbw               = param.CWbw;
	  AvgWF1->ItemIndex  = param.AvgIdx1;
	  AvgWF2->ItemIndex  = param.AvgIdx2;
	  skew               = param.skew;
	  Qmult              = param.Qmult;
	  swapIQ             = param.swapIQ;
	  Den2qfac           = param.Den2LvlPos;
	  BlkThr             = param.BlkThr;
	  vol                = param.vol;
	  wf1slow            = param.wf1slow;
	  Den1fac            = param.Den1fac;
	  WF1Contrast->Position = param.WF1ContrastPos;
	  WF2Contrast->Position = param.WF2ContrastPos;
	  sp1fullspeed       = param.sp1fullspeed;
	  polyfactor         = param.polyfactor;
	  revWF1scroll       = param.revWF1scroll;
	  wavdir             = param.wavdir;
	  wavname            = param.wavname;
	  WF1avg             = param.WF1avg;
	  WF2avg             = param.WF2avg;
	  extLOfreq          = param.extLOfreq;
	  extLOoffset		 = param.extLOoffset;
	  ComboBox4->Text = String(extLOoffset / 1000);
	  wfm_deemph_tau	 = param.wfm_deemph_tau;
	  ComboBox1->Text = String(int(.5 + wfm_deemph_tau * 1.e6));
	  wfm_rf_cut		 = param.wfm_rf_cut;
	  ComboBox2->Text = String(wfm_rf_cut / 1000);
	  wfm_audio_cut		 = param.wfm_audio_cut;
	  ComboBox3->Text = String(wfm_audio_cut / 1000);
	  leftdly            = param.leftdly;
	  rightdly           = param.rightdly;
	  processPriority    = param.procprio;
	  vollocked          = param.vollocked;
   }

   FF2locut = SSBFF2locut;
   FF2hicut = SSBFF2hicut;

   SettingsReg.CloseKey();
   delete &SettingsReg;
}
