//---------------------------------------------------------------------------
#include <vcl.h>
#include "pch.h"
#pragma  hdrstop

#include "ProcessFF1.h"
#define  MIN_INT 3             // 3-millisecond minimum interval

//---------------------------------------------------------------------------
__fastcall TProcessFF1::TProcessFF1(bool CreateSuspended)
		: TThread(CreateSuspended), firstpass(true), size(0), wf1time(false)
{
	ResetEvent(MainForm->FF1Terminate);

	interval = MIN_INT + (MainForm->WF1Speed->Max + 1 - MainForm->WF1Speed->Position);
	if(MainForm->wf1slow) interval *= 10;

	tint = (MainForm->sp1fullspeed) ? MIN_INT : interval;

}
//---------------------------------------------------------------------------
void __fastcall TProcessFF1::Execute()
{
   DWORD whichevent, numbytes;

   while (!Terminated)
   {
	  whichevent = WaitForSingleObject(MainForm->FF1Terminate, tint);

	  if(whichevent == WAIT_OBJECT_0)   // if audio terminate
	  {
		break;
	  }

	  interval = MIN_INT + (MainForm->WF1Speed->Max + 1 - MainForm->WF1Speed->Position);
	  if(MainForm->wf1slow) interval *= 10;

	  tint = (MainForm->sp1fullspeed) ? MIN_INT : interval;

// if not terminate, then must be WAIT_TIMEOUT

// if buffer ready or timeout and running
	  if((MainForm->running && (!MainForm->wavin || MainForm->wavin && !MainForm->paused)))
	  {
		 if((loopctr += tint) >= interval)
		 {
		   loopctr = 0;
		   wf1time = true;
		 }
		 else
		   wf1time = false;

		 if(wf1time) Synchronize(&ScrollWF1);

		 ComputeFF1IQ();

		 if(wf1time)
		 {
		   Synchronize(&PaintWF1);
		   wf1time = false;
		 }
	  }
  }
}
//---------------------------------------------------------------------------
void __fastcall TProcessFF1::DoSync()
{
	Synchronize(&DynW);
}
//---------------------------------------------------------------------------
void __fastcall TProcessFF1::DynW()
{
	EnterCriticalSection(&MainForm->screenUpdate);
	  MainForm->DynWrite();
	LeaveCriticalSection(&MainForm->screenUpdate);
}
//---------------------------------------------------------------------------


