//---------------------------------------------------------------------------
// This is the audio processign threads, which runs at a higher priority than the
// other threads in the program
//---------------------------------------------------------------------------
#include <vcl.h>
#include "pch.h"
#pragma  hdrstop


#define RDS_ENABLED	1
#define RDS_SAMPLE_BUFF_SIZE	(65536*4)

#include "ProcessIn.h"

//---------------------------------------------------------------------------
__fastcall TProcessIn::TProcessIn(bool CreateSuspended)
		: TThread(CreateSuspended)
{
	ResetEvent(MainForm->InBufferReady);
	ResetEvent(MainForm->InTerminate);
	offs = dstLen = hangcnt = 0;
	ZeroMemory(outLup, (BUFSIZE*MAXDOWN) * sizeof(int));
	ZeroMemory(outRup, (BUFSIZE*MAXDOWN) * sizeof(int));
	MainForm->PINidle = true;
	inIdx = 0;

	sleeptime = (float)BUFSIZE / MainForm->srateIn * 1000.;

	FF1fsamp_ready = 0;
}
//---------------------------------------------------------------------------
void __fastcall TProcessIn::Execute()
{
   DWORD whichevent, numbytes;
   HANDLE AudioEvents[2] = {MainForm->InTerminate, MainForm->InBufferReady};

   bool   found, outbReady;
   int    idxIn, idxOut, j, k;
   short  outL16[BUFSIZE], outR16[BUFSIZE];
   short  *out;
   static int inL32[BUFSIZE], inR32[BUFSIZE], outL32[BUFSIZE], outR32[BUFSIZE],
			  outL[BUFSIZE],   outR[BUFSIZE];

   while (!Terminated)
   {
	  whichevent = WaitForMultipleObjects(2, AudioEvents, FALSE, INFINITE);

      if(whichevent == WAIT_OBJECT_0)   // if audio terminate
	  {
		break;
	  }

// if not terminate, then must be audio buffer ready
	  if(whichevent == (WAIT_OBJECT_0 + 1))  // if audio ready
	  {
		MainForm->PINidle = false;
		if(MainForm->wavin)  // if reading from a WAV file
		{
		  if(!MainForm->paused)  // and not paused...
			 if(MainForm->driver == WMME)
				goto WMME_processing;
			 else
				goto ASIO_processing;   // should never happen...
		  else  // if paused clear the ASIO buffers to prevent noise
		  {
			if(MainForm->driver == ASIO)
			{
			  ZeroMemory(outL32, BUFSIZE * sizeof(int));
			  ZeroMemory(outR32, BUFSIZE * sizeof(int));
			  putASIOsamples(outL32, outR32);
			}
			continue; // reiterate while for next event (paused)
		  }
		}

		if(MainForm->extio)
		   MainForm->inQued = GetExtIOdata();

newExtIOdata:
// if WMME drivers
		if(MainForm->driver == WMME)
WMME_processing:
		{
		  while(MainForm->inQued > 0)
		  {
			if(!MainForm->wavin)
			{
			  if(!MainForm->extio && MainForm->inQued >= NINBUF - 2)
			  {
				 SoundCloseIn();   SoundCloseOut();
				 SoundOpenIn();  waveInStart(hin);  SoundOpenOut();
				 break;
			  }

			  if(!getBufPtrIn(idxIn, inL, inR))  // shift to 24 done inside the getBufPtrIn
				break;                           // unless data are floats32

			  ReQueIn(idxIn);

			  if(!sndOutOpen && !MainForm->extio)
				goto waitNextevent;  // reiterate while not terminated
			}

			MainForm->inQued--;

			if(!MainForm->wavin && MainForm->outQued > OUTBUFFERMARK + 10) //NOUTBUF/8 * 7)
			  goto skipThis;

// ----------- Process audio data here ----------------------
doit_again:
			outbReady = ProcessAudio(inL, inR, outL, outR);
// ----------------------------------------------------------

			if(outbReady)
			{
// check if upsampling needed, and, if yes, do it
			  dstLen = UpsampleMME(outL, outR, outLup, outRup);
			  offs = 0;

			  while(dstLen >= BUFSIZE)
			  {
				out = getBufPtrOut(idxOut); // idxOut is returned from the function
				if(out)
				{
					short *pout = out;
					int *poutRup = outRup + offs;
					int *poutLup = outLup + offs;
					// for(j = 0, k = 0; k < BUFSIZE*2; )
					for(j = 0, k = 0; k < BUFSIZE; k++)
					{
						// out[k++] = outLup[j   + offs] >> 8;
						*pout++ = *poutLup++ >> 8;
						// out[k++] = outRup[j++ + offs] >> 8;
						*pout++ = *poutRup++ >> 8;
					}
					ReQueOut(idxOut);
					offs += BUFSIZE;

					if(MainForm->outQued <= 1)
					{
						waveOutPause(hout);
						restarted = false;
					}
				}
				else
				{ waveInStop(hin);
				  while(MainForm->outQued > NINBUF/4) // process some outbuffers
					 Sleep(64);
				  waveInStart(hin);
				  goto waitNextevent;                 // before continuing
				}
				dstLen -= BUFSIZE;
			  }
			  MainForm->normQue = MainForm->outQued;
			}   // if outbReady

			if(!MainForm->wavin && restarted && MainForm->outQued < OUTBUFFERMARK - 2)
			{
//			  goto doit_again;
			}
skipThis:
			if(MainForm->wavin && !MainForm->paused)
			{
recheck:
			  if(MainForm->outQued <= OUTBUFFERMARK)
			  {
wread:          MainForm->PIn->wreadlen = BUFSIZE;
				MainForm->IWav->InRead(inL, inR, MainForm->PIn->wreadlen);

				if(MainForm->PIn->wreadlen != BUFSIZE)
				{
				  if(MainForm->wlooping)
				  {
					MainForm->IWav->InRewind();
					goto wread;
				  }

				  ResetOut();
				  MainForm->paused = true;
				  MainForm->IWav->InRewind();
				  goto waitNextevent;  // reiterate while not terminated
				}

				MainForm->inQued++;
				SetEvent(MainForm->InBufferReady);  // this cause an immediate reiteration, but
				goto waitNextevent;                 // with a check first for termination
			  }
// if through here, outQued > OUTBUFFERMARK
			  Sleep(50);  // wait one buffer time (about...)
			  goto recheck;
			}   // if wavin

		  }    // while(MainForm->inQued > 0)

		  MainForm->PINidle = true;
		}
		else   // if not WMME, then ASIO
		{
ASIO_processing:
		  while(--MainForm->asioINfilled >= 0)
		  {
// get new audio data
			if(MainForm->wavin && MainForm->EoF)
			{
			  MainForm->WPauseClick(NULL);
			  MainForm->IWav->InRewind();
			  MainForm->EoF = false;
			  goto waitNextevent;
			}

			getASIOsamples(inL32, inR32);

			int *pinL = inL;
			int *pinR = inR;
			int *pinL32 = inL32;
			int *pinR32 = inR32;

			for(k=0; k < BUFSIZE; k++)
			{
			  // inL[k]  = inL32[k] >> 8;
			  *pinL++  = *pinL32++ >> 8;
			  // inR[k]  = inR32[k] >> 8;
			  *pinR++  = *pinR32++ >> 8;
			}

			if(!ProcessAudio(inL, inR, outL, outR))
			  continue;   // reiterate while asioInfilled >= 0

			dstLen = UpsampleASIO(outL, outR, outLup, outRup);
			offs = 0;

			while(dstLen >= BUFSIZE)
			{
			  for(k=0; k < BUFSIZE; k++)
			  {
				 outL32[k] = outLup[k + offs] << 8;
				 outR32[k] = outRup[k + offs] << 8;
			  }
			  offs += BUFSIZE;
// write audio data
			  putASIOsamples(outL32, outR32);
			  dstLen -= BUFSIZE;
			}

		  }
		  continue;   // reiterate while(!Terminated) loop
		} // end ASIO case

	  }  // if audio ready

	  if(MainForm->extio && (MainForm->inQued = GetExtIOdata()) > 0)
		 goto newExtIOdata;

waitNextevent:
   }   // while not terminated
}
//---------------------------------------------------------------------------
// processing in ProcessAudio is done with 24-bit resolution,
// Execute will shift WMME from 16 to 24 and ASIO from 32 to 24

bool __fastcall TProcessIn::ProcessAudio(void *inL24,  void *inR24,
										 int  *outL24, int  *outR24)
{
	int    j, k, len;
	SCplx  LRsamp[2 * BUFSIZE], LRsampP[BUFSIZE], LRvideo[BUFSIZE], *LRptr;
	float  Lsamp[BUFSIZE+4], Rsamp[BUFSIZE+4];   // the separate L and R samples (+4 for the delay)
	float  LsampAbs[BUFSIZE], RsampAbs[BUFSIZE]; // the absolute values
	float  Samp[BUFSIZE];                  // either L or R or both added
	SCplx  tmpSamp[AFFTLEN];               // temporary decimated samples
	SCplx  tmpSamptmp[AFFTLEN];               // temporary decimated samples
	SCplx  downLRsamp[BUFSIZE];            // the decimated LR samples
	SCplx  buffLRsamp[BUFSIZE*4];          // the decimated LR samples
										   // accumulated in a BUFSIZE buffer
	static SCplx  FF1fsamp[AFFTLEN + 2];
	SCplx FF1fsampECSS[AFFTLEN + 2];
	SCplx  IQtmp[AFFTLEN];                 // temporary for ComputePhase

	float FF2temp[AFFTLEN + 2], dtmp;
	float FF2tempStereo[AFFTLEN + 2];
	static float FF2audio[BUFSIZE];
	static float FF2audioStereo[BUFSIZE * 2];
	float FF2audioECSS[BUFSIZE];
	float mag[AFFTLEN], ph[AFFTLEN];
	float  tmp, d_downbuf[BUFSIZE], *pl, *pr;
	bool  over;

	static int loop2ctr = 0, direct, inverse, size=0, order;
	static SCplx AudioBuff[AFFTLEN], noiseMask[AFFTLEN];

	static float ss, pk, pk2, smlev = 0., LoCutNorm, HiCutNorm,
				 AudioHzPerBin, peakvol, normconst;
	static int   tmpbuf[BUFSIZE], bufLen, bufIdx;
	static int   tmpbufStereo[BUFSIZE];

	float vol, denorm;

	static runmode oldmode = NONE;
	static submode oldsubmode = lower;

	if(MainForm->mode != oldmode || MainForm->submode != oldsubmode)
	{
		oldmode = MainForm->mode;
		oldsubmode = MainForm->submode;
		ss = pk = pk2 = 0.;
		hangcnt = 0;
		// MainForm->StartStopClick(MainForm->StartStop);
		// MainForm->StartStopClick(MainForm->StartStop);
	}


// init FFT and other things
	if(size != AFFTLEN)
	{
	  nspzFreeTwdTbls();
	  nspFreeBitRevTbls();

	  size    = AFFTLEN;
	  order   = (int)(log(size)/log(2.) +0.0001); // povero Borland....
	  direct  = NSP_Forw | NSP_NoBitRev;
	  inverse = NSP_Inv  | NSP_NoBitRev;
	  nspzFft(NULL, order, (direct | NSP_Init));
	  for(k=0; k<AFFTLEN + 2; k++) FF1fsamp[k].re = FF1fsamp[k].im = 0.;
	}

	if(MainForm->justStarted)
	{
	  AudioHzPerBin = MainForm->vsrOut / size;
	  ss = 0.; pk = pk2 = 0.;  peakvol = 0.;
	  bufLen = bufIdx = 0;
	  ZeroMemory(AudioBuff, AFFTLEN * sizeof(SCplx));

	  if((MainForm->extio && MainForm->perseus)  ||   // if Perseus HW connected
		 (MainForm->wavin && MainForm->perseuswav))   // or Perseus wav playback

		 normconst = NORMCONSTP;
	  else
		 normconst = NORMCONST;

	  if(MainForm->extHWtype == SDR14)
		 normconst /= 3.1623F;         // attenuate SDR-14 & SDR-IQ by 10 dB
	}
// if needed, compute the new passband filter
	if(MainForm->bpchanged)
	{
	  LoCutNorm = MainForm->bpLocut/MainForm->vsrOut;
	  HiCutNorm = MainForm->bpHicut/MainForm->vsrOut;
	  ComputeMask(MainForm->FF2mask, size, order, LoCutNorm, HiCutNorm);
	  MainForm->Compute_IIR_parms();
	  MainForm->bpchanged = false;
	}

// Give out the raw data, if an entry point for this exists in an extio DLL

	if(MainForm->RawDataReady)
	  MainForm->RawDataReady(MainForm->srateIn, inL24, inR24, BUFSIZE);

	if(MainForm->wrec == wrecording  && !MainForm->werror)
	  if(!MainForm->OWav->OutWrite((unsigned int *)inL24, (unsigned int *)inR24, BUFSIZE))
		MainForm->werror = true;

	pl = Lsamp;  pr = Rsamp;  // point to the beginning of the buffers

	for(int k = 0; k < MainForm->rightdly; k++)
	{
	  *pr = Rsamp[BUFSIZE + k];  pr++;  // delay right channel as left
	}

	for(int k = 0; k < MainForm->leftdly; k++)
	{
	  *pl = Lsamp[BUFSIZE + k];  pl++;  // delay left channel as right
	}

	if(MainForm->extHWtype == USBfloat32)
	{
	  memcpy(pl, inL24, BUFSIZE * sizeof(float));
	  memcpy(pr, inR24, BUFSIZE * sizeof(float));
	}
	else
	{
	  nspsbIntToFloat(inL24, pl, BUFSIZE, 8*sizeof(int), NSP_Noflags);
	  nspsbIntToFloat(inR24, pr, BUFSIZE, 8*sizeof(int), NSP_Noflags);
    }

	if(MainForm->extio && MainForm->IQoffset != 0.F &&
						  (MainForm->extHWtype == SDR14 ||
						   MainForm->extHWtype == USBdata16 ||
						   MainForm->extHWtype == USBdata24))
	{
	  for(k = 0; k < BUFSIZE; k++)
	  {
		Lsamp[k] += MainForm->IQoffset;
		Rsamp[k] += MainForm->IQoffset;
	  }
	}

	if(MainForm->extHWtype != USBfloat32)  // if floats, they are already normalized
	{
	  nspsbMpy1(normconst, Lsamp, BUFSIZE);   // normalize to 1.
	  nspsbMpy1(normconst, Rsamp, BUFSIZE);   //  -----------
	}

	switch(MainForm->datamode)
	{
	  case mLeft      : nspcb2RealToCplx(Lsamp, Lsamp, LRsampP, BUFSIZE);
						break;

	  case mRight     : nspcb2RealToCplx(Rsamp, Rsamp, LRsampP, BUFSIZE);
						break;

	  case mLeftRight : nspsbAdd3(Lsamp, Rsamp, Samp, BUFSIZE);
						nspcb2RealToCplx(Samp, Samp, LRsampP, BUFSIZE);
						break;

	  case mIQ        : if(MainForm->skew  != 0.)
//                           FDFilter(Lsamp, Rsamp);
						{
						  memcpy(Samp, Rsamp, sizeof(float)*BUFSIZE);
						  nspsbMpy1(MainForm->skew, Samp, BUFSIZE);
						  nspsbAdd2(Samp, Lsamp, BUFSIZE);
						}
						if(MainForm->Qmult != 1.)
						   nspsbMpy1(MainForm->Qmult, Rsamp, BUFSIZE);
						if(MainForm->swapIQ)
						   nspcb2RealToCplx(Rsamp, Lsamp, LRsampP, BUFSIZE);
						else
						   nspcb2RealToCplx(Lsamp, Rsamp, LRsampP, BUFSIZE);
						break;
	}

// Pre FF1 processing

//	memcpy(LRvideo, LRsampP, sizeof(SCplx) * BUFSIZE);

	if(MainForm->nblanker)
	{

	   static float avgmag = 0, avglvlRe = 0., avglvlIm = 0., mag;
	   static SCplx avglvl = SCplxZero;
	   SCplx lvl;

	   for(k = 0; k < BUFSIZE; k++)
	   {
		 int j;

		 mag = sqrt(LRsampP[k].re * LRsampP[k].re + LRsampP[k].im * LRsampP[k].im);
		 avgmag = 0.99999 * avgmag + 0.00001 * mag;
		 avglvlRe = 0.999 * avglvlRe + 0.001 * LRsampP[k].re;
		 avglvlIm = 0.999 * avglvlIm + 0.001 * LRsampP[k].im;

		 if(mag > (MainForm->BlkThr * avgmag * 0.55))
		 {
		   LRsamp[k].re = (LRsampP[k].re > 0.) ? avglvlRe : -avglvlRe;
		   LRsamp[k].im = (LRsampP[k].im > 0.) ? avglvlIm : -avglvlIm;

		   for(j = 1; j < 3 && (k - j) >= 0; j++)
		   {  LRsamp[k-j].re = (LRsampP[k-j].re > 0.) ? avglvlRe : -avglvlRe;
			  LRsamp[k-j].im = (LRsampP[k-j].im > 0.) ? avglvlIm : -avglvlIm;
		   }

		   for(j = 1; j < 3 && (k + j) < BUFSIZE; j++)
		   {  LRsamp[k+j].re = (LRsampP[k+j].re > 0.) ? avglvlRe : -avglvlRe;
			  LRsamp[k+j].im = (LRsampP[k+j].im > 0.) ? avglvlIm : -avglvlIm;
		   }

		 }
		 else  // if threshold not exceeded
		   LRsamp[k] = LRsampP[k];

	   }
	   LRptr = LRsamp;  // point to "blanked" buffer
	}
	else  // if no blanker activated
	  LRptr = LRsampP;  // point to original (unblanked) buffer

	EnterCriticalSection(&MainForm->acFF1que);
	{
	  memcpy(MainForm->PFF1->PolyQue, MainForm->PFF1->PolyQue + BUFSIZE,
			 (MainForm->ff1Size * MainForm->polyfactor - BUFSIZE) * sizeof(SCplx));

	  memcpy(MainForm->PFF1->PolyQue + (MainForm->polyfactor * MainForm->ff1Size - BUFSIZE),
			 LRptr, BUFSIZE * sizeof(SCplx));
	}
	LeaveCriticalSection(&MainForm->acFF1que);

//*************************************
	if(MainForm->despreading)
	   PreFF1Proc(LRptr);
//*************************************

// downconvert the complex (L, R) input
	DownConvert(LRptr, tmpSamp);


	//
	// AlpAdd - BEGIN
	//

	// For wide FM we must perform frequency
	// demodulation before to downsampling, since
	// downsampling must be carried out in
	// time domain.

	// In this case, switch back to narrowband FM
	/* if(MainForm->mode == FM && MainForm->submode != lower &&
		MainForm->srateIn < 96000)
	{
		MainForm->BFMMouseDown(Sender, LEFT);
		MainForm->AdjustBlueWindow();
	}*/


	if(MainForm->mode == FM && MainForm->submode != lower)
	{
		/*
		float const f1 = 1.e3;
		float const w1_samp = twoPI * f1 / float(MainForm->srateIn);
		static float cph = 0.;
		static float mph = 0.;
		for(k = 0; k < BUFSIZE; k++)
		{
			mph += w1_samp;
			cph += 1 * sin(mph) * w1_samp;
			tmpSamp[k].re = 0.002 * cos(cph);
			tmpSamp[k].im = 0.002 * sin(cph);
		}
		mph -= twoPI * floor(mph / twoPI);
		cph -= twoPI * floor(cph / twoPI);
		/**/
		
		WideFM_PreDecProc(tmpSamp);
	}

	// Now we have a narrow-band audio signal (L+R) in tmpSamp[].re
	// and the corresponding (L-R) signal in tmpSamp[].im

	//
	// AlpAdd - END
	//


	// static char done = 1;



	// Decimate the baseband signal, return false if a BUFSIZE buffer not ready yet
	// if(!SincDecimate(tmpSamp, LRsamp))
	if(!SincDecimate(tmpSamp, AudioBuff + (AFFTLEN-BUFSIZE)))
	{
		MainForm->justStarted = false;
		if(FF1fsamp_ready)
		{
			WideFM_PostDecProc_2(FF1fsamp, FF2audio, FF2audioStereo);
			FF1fsamp_ready = 0;
			goto WFM_reentry;
		}
		return false;
	}
	MainForm->justStarted = false;
	MainForm->procAudio = true;


// queue the downconverted and decimated signal for the audio FFT
	// memmove(AudioBuff, AudioBuff + BUFSIZE,  (AFFTLEN-BUFSIZE) * sizeof(SCplx));
	// memmove(AudioBuff + (AFFTLEN-BUFSIZE), LRsamp, BUFSIZE * sizeof(SCplx));

// recover the phase offset between the AM carrier and the local NCO
	if(MainForm->mode == AM || MainForm->mode == ECSS)
		phase = ComputePhase(AudioBuff + (AFFTLEN-BUFSIZE));
	else
		MainForm->freqerr = phase = 0.F;


	Synchronize(&UpdatePM);


	// Compute the complex FFT of the downconverted audio
	nspcFftNip(AudioBuff, FF1fsamp, order, direct);

	// Make room for the next audio chunk
	memmove(AudioBuff, AudioBuff + BUFSIZE,
			(AFFTLEN-BUFSIZE) * sizeof(SCplx));

	if(MainForm->mode == FM && MainForm->submode != lower)
	{
		/**/
		WideFM_PostDecProc_1(FF1fsamp, FF2audio, FF2audioStereo);
		// WideFM_PostDecProc_2(FF1fsamp, FF2audio, FF2audioStereo);
		FF1fsamp_ready = 1;
		return false;
		/**/
		/*
		WideFM_PostDecProc(FF1fsamp, FF2audio, FF2audioStereo);
		FF1fsamp_ready = 1;
		return false;
		// goto WFM_reentry;
		*/
	}

	if(MainForm->mode != AM && MainForm->mode != FM)
	   FF1fsamp[0].re = FF1fsamp[0].im = FF1fsamp[AFFTLEN-1].re = FF1fsamp[AFFTLEN-1].im =
	   FF1fsamp[1].re = FF1fsamp[1].im = FF1fsamp[AFFTLEN-2].re = FF1fsamp[AFFTLEN-2].im = 0.F;

// mirror the upper half of the FFT into the
// lower half, when processing the LSB
	if(MainForm->mode == LSB)
	  for(k=1, j=AFFTLEN-1; k<AFFTLEN/2; k++, j--)
	  {
		FF1fsamp[k].re =  FF1fsamp[j].re;
		FF1fsamp[k].im = -FF1fsamp[j].im;
	  }

	if(MainForm->mode == ECSS && MainForm->submode != upper)
	{
	  ZeroMemory(FF1fsampECSS, sizeof(SCplx) * (AFFTLEN +2));
	  for(k=1, j=AFFTLEN-1; k<AFFTLEN/2; k++, j--)
	  {
		FF1fsampECSS[k].re =  FF1fsamp[j].re;
		FF1fsampECSS[k].im = -FF1fsamp[j].im;
	  }
	}

	if(MainForm->fullview && MainForm->mode == CW)
	{
// do an inverse FFT of only the first half of the complex spectrum.
// recovering a real audio signal
	  nspsCcsFftNip(FF1fsamp, FF2temp, order, inverse);
// apply the overlap-and-save algorithm
	  memcpy(FF2audio, FF2temp + (AFFTLEN-BUFSIZE), BUFSIZE * sizeof(float));


	  EnterCriticalSection(&MainForm->acFF2que);
		 memmove(MainForm->PFF2->PolyQue, MainForm->PFF2->PolyQue + BUFSIZE,
				(MainForm->ff2Size * MainForm->polyfactor - BUFSIZE) * sizeof(float));
		 memcpy(MainForm->PFF2->PolyQue + (MainForm->polyfactor * MainForm->ff2Size - BUFSIZE),
				FF2audio, BUFSIZE * sizeof(float));
	  LeaveCriticalSection(&MainForm->acFF2que);
	}


// multiply the complex spectrum by the complex bandpass filter
	if(MainForm->mode != FM) nspcbMpy2(MainForm->FF2mask, FF1fsamp, AFFTLEN);

	if(MainForm->mode == ECSS && MainForm->submode != upper)
	  nspcbMpy2(MainForm->FF2mask, FF1fsampECSS, AFFTLEN/2);

	if(MainForm->mode == LSB || MainForm->mode == USB ||
	   MainForm->mode == CW || MainForm->mode == DRM)
	{
// do an inverse FFT of only the first half of the complex spectrum.
// recovering a real audio signal
	  nspsCcsFftNip(FF1fsamp, FF2temp, order, inverse);
// apply the overlap-and-save algorithm
	  memcpy(FF2audio, FF2temp + (AFFTLEN-BUFSIZE), BUFSIZE * sizeof(float));
	}
	else  if(MainForm->mode == ECSS)
	{
	  if(!MainForm->locked) goto am_demod;

	  if(MainForm->submode != lower)
	  {
// do an inverse FFT of only the first half of the complex spectrum.
// recovering a real audio signal from the upper spectrum (USB)
		nspsCcsFftNip(FF1fsamp, FF2temp, order, inverse);
// apply the overlap-and-save algorithm
		memcpy(FF2audio, FF2temp + (AFFTLEN-BUFSIZE), BUFSIZE * sizeof(float));
	  }

	  if(MainForm->submode != upper)
	  {
// do an inverse FFT of only the first half of the complex spectrum.
// recovering a real audio signal from the lower spectrum (LSB)
		nspsCcsFftNip(FF1fsampECSS, FF2temp, order, inverse);
// apply the overlap-and-save algorithm
		memcpy(FF2audioECSS, FF2temp + (AFFTLEN-BUFSIZE), BUFSIZE * sizeof(float));
	  }

	  if(MainForm->submode == both)
		nspsbAdd2(FF2audioECSS, FF2audio, BUFSIZE);

	  if(MainForm->submode == lower)
		memcpy(FF2audio, FF2audioECSS,  BUFSIZE * sizeof(float));

// if submode == upper, the vector FF2audio has already the right contents

	}
	else if(MainForm->mode == AM)
	{
am_demod:
	  nspcFft(FF1fsamp, order, inverse);           // inverse complex FFT
	  memcpy(tmpSamp, FF1fsamp + (AFFTLEN-BUFSIZE), sizeof(SCplx)*BUFSIZE);

	  nspcbMag(tmpSamp, FF2temp, BUFSIZE);         // just compute the magnitude and the
												   // demodulation is done !

	  HighPassFilter(FF2temp, FF2audio, BUFSIZE);  // cut everything below 150 Hz
	}
	else if(MainForm->mode == FM)
	{
//  FM demodulator ---------------------------------
		float divisor;
		const int len = (AFFTLEN - BUFSIZE)/2;

		nspcFft(FF1fsamp, order, inverse);           // inverse complex FFT

		for( k=0; k<BUFSIZE; k++ )
		{
		   divisor = FF1fsamp[k+len].re * FF1fsamp[k+len].re +
				   FF1fsamp[k+len].im * FF1fsamp[k+len].im;

		   if( divisor != 0.0 )
		   {
			   FF2temp[k] = (FF1fsamp[k+len].im * FF1fsamp[k+len-1].re -
					  FF1fsamp[k+len].re * FF1fsamp[k+len-1].im) / divisor;
			   FF2temp[k] *= 5.e-3F;
		   }
		   else				// AlpAdd
		   {           	    // AlpAdd
		       FF2temp[k] = k ? FF2temp[k - 1] : 0.;   // AlpAdd
		   }              	// AlpAdd
	  }




	  HighPassFilter(FF2temp, FF2audio, BUFSIZE);  // cut everything below 150 Hz
	}




	
	if(!(MainForm->fullview && MainForm->mode == CW))
	{
	  EnterCriticalSection(&MainForm->acFF2que);
		 memmove(MainForm->PFF2->PolyQue, MainForm->PFF2->PolyQue + BUFSIZE,
			 (MainForm->ff2Size * MainForm->polyfactor - BUFSIZE) * sizeof(float));
		 memcpy(MainForm->PFF2->PolyQue + (MainForm->polyfactor * MainForm->ff2Size - BUFSIZE),
				FF2audio, BUFSIZE * sizeof(float));
	  LeaveCriticalSection(&MainForm->acFF2que);
	}

	if((loop2ctr++ % (21 - MainForm->WF2Speed->Position)) == 0)
	  SetEvent(MainForm->FF2BufferReady);  // compute a new FF2 screen, by
										   // awakening ProcessFF2, which then
										   // will call ComputeFF2

	if(MainForm->cwp)
	{ if(MainForm->mode == CW)
	  {
		MainForm->DoPeak(FF2audio);
		MainForm->DoPeak2(FF2audio);
	  }
	  else // USB or LSB
		;
	}
// ------------------ AGC ------------------------------
	nspsbAbs2(FF2audio, FF2temp, BUFSIZE);
	if(MainForm->agc != off)
	{						// AlpAdd
		float const *tptr_FF2temp = FF2temp;
		float *tptr_au = FF2audio;
		float *tptr_aus = FF2audioStereo;
		float fact;
		float const c1 = 0.9;
		for (k = 0; k < BUFSIZE; k++)
		{
			tmp = *tptr_FF2temp++;

			if(ss < tmp)
			{ // ss = (9. * ss + tmp) / 10.;    // slow down attack time
				ss += 0.1 * (tmp - ss);
			  pk = tmp;
			  hangcnt = (MainForm->agc == fast) ? 1 : 6;
			}

			// float fact = 0.9 / max(ss, MainForm->agcthr);
			fact = c1 / max(ss, MainForm->agcthr);
			*tptr_au++ *= fact;
			*tptr_aus++ *= fact;  // AlpAdd
			if(!hangcnt) ss  *= MainForm->agc_decay;

			pk  *= MainForm->agc_decay;
		}
	}
	else
	{
		float const *tptr_FF2temp = FF2temp;
		float *tptr_au = FF2audio;
		float *tptr_aus = FF2audioStereo;
		float fact;
		float const c1 = 0.9;
		for (k = 0; k < BUFSIZE; k++)
		{
			tmp = *tptr_FF2temp++;

			if(ss < tmp)
			{ // ss = (9. * ss + tmp) / 10.;    // slow down attack time
				ss += 0.1 * (tmp - ss);
			  pk = tmp;
			  hangcnt = (MainForm->agc == fast) ? 1 : 6;
			}

			fact = 3.e3 * MainForm->agcgain;
			*tptr_au++ *= fact;
			*tptr_aus++ *= fact;     //AlpAdd
			if(!hangcnt) ss  *= MainForm->agc_decay;

			pk  *= MainForm->agc_decay;
		}
	}

	if(hangcnt > 0)  hangcnt--;
// ------------------------------------------------------

	MainForm->pklevel = pk;

	Synchronize(&UpdateVU);

	// nspsbMpy1(ONEFIFTH, FF2audio , BUFSIZE); // denormalize...
	// nspsbMpy1(ONEFIFTH, FF2audioStereo, BUFSIZE); // AlpAdd: denormalize...

//	if(MainForm->nr)   // the rotine is always executed to allow for fast convergence
	{                  // but its output is used only when nr is true
	   MainForm->WideBandDenoiser(FF2audio);
	}


	vol = pow((float)MainForm->vol/99., 2);
	// vol = (MainForm->audiomute) ? 0. :  (MainForm->vol * MainForm->vol) / (99. * 99.);
	if(MainForm->audiomute)
		vol = 0.;

	denorm = vol * 3. * twoTO23m1 * (MainForm->nr ? 1.5 : 1.) / ONEFIFTH;
	// denorm /= ONEFIFTH;

	nspsbMpy1(denorm, FF2audio , BUFSIZE);		// denormalize...
	nspsbMpy1(denorm, FF2audioStereo, BUFSIZE);	// AlpAdd: denormalize...

	// do
	//{
	  nspsbAbs2(FF2audio, FF2temp, BUFSIZE);
	  peakvol = nspsMax(FF2temp, BUFSIZE);
	  if(peakvol > 0.995 * twoTO23m1)
	  {
		// nspsbMpy1(0.98F, FF2audio , BUFSIZE);
		nspsbMpy1((0.99 * twoTO23m1) / peakvol, FF2audio , BUFSIZE);
		if(MainForm->mode == FM && MainForm->submode == both)  // AlpAdd
			nspsbMpy1((0.99 * twoTO23m1) / peakvol, FF2audioStereo, BUFSIZE); // AlpAdd: denormalize...
		over = true;
	  }
	  else over = false;
	//} while(over);

	MainForm->overload = false;
	// MainForm->overload = over;




WFM_reentry:
	// Reconvert to integers
	nspsbFloatToInt(FF2audio, tmpbuf, BUFSIZE, 8*sizeof(int),
							   NSP_Round | NSP_Clip);


	int *tptr_outL24 = outL24;
	int *tptr_outR24 = outR24;
	int const *tptr_tmpbuf = tmpbuf;
	for(int k=0; k<BUFSIZE; k++)
	{
	  *tptr_outL24++ = *tptr_tmpbuf;  // left channel
	  *tptr_outR24++ = *tptr_tmpbuf++;  // right channel
	}


	//
	// AlpAdd: Stereo output - BEGIN
	//
	if(MainForm->mode == FM && MainForm->submode == both)
	{
		nspsbFloatToInt(FF2audioStereo, tmpbufStereo, BUFSIZE,
			8*sizeof(int), NSP_Round | NSP_Clip);

		tptr_outL24 = outL24;
		tptr_outR24 = outR24;
		int const *tptr_tmpbufStereo = tmpbufStereo;
		for(int k=0; k<BUFSIZE; k++)
		{
		  *tptr_outL24++ += *tptr_tmpbufStereo;  		 // Left channel
		  *tptr_outR24++ -= *tptr_tmpbufStereo++; 		 // Right channel
		}
	}
	//
	// AlpAdd: Stereo output - END
	//

	return true;
}
//---------------------------------------------------------------------------
void __fastcall TProcessIn::UpdateVU()
{
#define S9p50  0.1088    // measured pklevel at -23 dBm == S9 + 50 dB (S-meter full scale)
#define S1m12  0.344e-6  // pklevel at S1 - 12 dB (S-meter zero scale)

// 14.14 is 20 * 0.707 (RMS / peak)

	float val = 14.14F * log10(1.e-15 +  // this term only to prevent log(0)
						MainForm->pklevel / S9p50);

	MainForm->VU->Position = MainForm->VU->Scale + val;
}
//---------------------------------------------------------------------------
void __fastcall TProcessIn::UpdatePM()
{
	MainForm->PM->Value = int(phase);
}
//---------------------------------------------------------------------------
void __fastcall ComputeMask(SCplx *mask, int size, int order, float lo, float hi)
{
	double hre[4096];
	SCplx  hs[4096];
	int    k;

	lo = max(lo, 0.001F);    hi = max(0.002F, min(hi, 0.499F));
	hi = max(hi, lo + 0.001F);

	if(MainForm->mode == AM)
	  nspdFirLowpass(hi, hre, size - BUFSIZE + 1, NSP_WinBlackmanOpt, 1);
	else
	  nspdFirBandpass(lo, hi, hre, size - BUFSIZE + 1, NSP_WinBlackmanOpt, 1);
	for(k = size - BUFSIZE + 1; k < size; k++) hre[k] = 0.;
	for(k = 0; k < size; k++) {hs[k].re = hre[k]; hs[k].im = hs[k].re;}
	nspcFftNip(hs, mask, order, NSP_Forw | NSP_NoBitRev);
}
//---------------------------------------------------------------------------
int __fastcall UpsampleMME(int* outL, int* outR, int* outLup, int* outRup)
{
   int    dstLen;

   {
	 dstLen = BUFSIZE;
	 nspsbCopy((float *)outL, (float *)outLup, BUFSIZE);
	 nspsbCopy((float *)outR, (float *)outRup, BUFSIZE);
	 return dstLen;
   }
}
//---------------------------------------------------------------------------
int __fastcall UpsampleASIO(int* outL, int* outR, int* outLup, int* outRup)
{
   int    dstLen;
   static float oldcutoff = 0., cutoff;
   double foutLup[BUFSIZE * MAXDOWN], foutL[BUFSIZE];

   if(MainForm->downFactor == 1)
   {
	 dstLen = BUFSIZE;
	 nspsbCopy((float *)outL, (float *)outLup, BUFSIZE);
	 nspsbCopy((float *)outR, (float *)outRup, BUFSIZE);
	 return dstLen;
   }

   cutoff = (MainForm->vsrOut * 0.49) / MainForm->srateOut;

   if(oldcutoff != cutoff) // then compute the new anti-alias filter taps
   {
	 if(NSP_StsOk != nspdFirLowpass(cutoff, dtapValsUP, LPFIRUPLEN,
												   NSP_WinBlackmanOpt, 1))
	 { fatal("An error occurred when computing the upsampling anti-alias filter");
	   Application->Terminate();
	 }

	 if(oldcutoff != 0.)  // if at least one time through before...
	   nspFirFree(&MainForm->statePtrUP);

	 oldcutoff = cutoff;
	 nspdFirInitMr(dtapValsUP, LPFIRUPLEN, NULL, MainForm->downFactor, 0,
												  1, 0, &MainForm->statePtrUP);
   }

// and now finally upsample and lowpass the audio data
   dstLen = BUFSIZE * MainForm->downFactor;

// convert to doubles for upsampling
   nspdbIntToFloat(outL, foutL, BUFSIZE, 8*sizeof(int), NSP_Noflags);

// keep the volume constant, despite the upsampling
   nspdbMpy1(MainForm->downFactor, foutL, BUFSIZE);

// do the upsampling followed by filtering
   nspdbFir(&MainForm->statePtrUP,  foutL, foutLup, BUFSIZE);

// reconvert to integers
   nspdbFloatToInt(foutLup, outLup, dstLen, 8*sizeof(int),
											   NSP_Round | NSP_Clip);
// for the time being, the right channel is equal to the left channel
   nspsbCopy((float *)outLup, (float *)outRup, dstLen);

   return dstLen;
}//---------------------------------------------------------------------------
int __fastcall Median5(float *q, int k)
{
	int idx[5] = {0, 1, 2, 3, 4};
	float p[5];

#define PIX_SORT(a,b) { if (p[a]>p[b]) PIX_SWAP(a,b); }
#define PIX_SWAP(a,b) { float temp=p[a]; p[a]=p[b]; p[b]=temp; \
						int t=idx[a]; idx[a]=idx[b]; idx[b]=t; }

	memcpy(p, q + k - 2, 5 * sizeof(float));
	PIX_SORT(0,1) ; PIX_SORT(3,4) ; PIX_SORT(0,3) ;
	PIX_SORT(1,4) ; PIX_SORT(1,2) ; PIX_SORT(2,3) ;
	PIX_SORT(1,2) ;
	return k - 2 + idx[2];
}
//---------------------------------------------------------------------------
// swaps the first half of the vector with the second half
void __fastcall Swap(DCplx vec[], int size)
{
   int k, j; DCplx tmp;

   for(k=0; k<size/2; k++)
   {
	 j = k + size/2;

	 tmp    = vec[k];
	 vec[k] = vec[j];
	 vec[j] = tmp;
   }
}
//---------------------------------------------------------------------------



//
// Wide FM: pre-decimation processing
//
void __fastcall TProcessIn::WideFM_PreDecProc(SCplx *tmpSamp)
{

	static SCplx IQBuff[AFFTLEN + 2];
	float Fs = MainForm->srateIn; 		// Sample rate [samples per second]
	float Fa = MainForm->srateOut;     	// Output (audio) sample rate
										// [samples per second]
	float f_t;                         	// Cutoff frequency
	float f_t1;                        	// Cutoff frequency
	int order1;                         // FFT order
	float gfact;

	static int direct  = NSP_Forw | NSP_NoBitRev;
	static int inverse = NSP_Inv  | NSP_NoBitRev;

	int k;

	static SCplx ts0;
	static float rs0;
	static float xkm1 = 0.;
	static float ykm1 = 0.;
	static float phi = 0.;

#ifdef RDS_ENABLED
	static float rds_phi = 0.;
	static SCplx rds_sample_buff[RDS_SAMPLE_BUFF_SIZE];
	static int rds_sample_buff_idx = 0;
#endif



	// Generating some test signals
	/*
	float const f1 = 1.e3;
	float const w1_samp = twoPI * f1 / float(Fs);
	static float cph = 0.;
	static float mph = 0.;
	for(k = 0; k < BUFSIZE; k++)
	{
		mph += w1_samp;
		cph += 50 * sin(mph) * w1_samp;
		tmpSamp[k].re = 0.002 * cos(cph);
		tmpSamp[k].im = 0.002 * sin(cph);
	}
	mph -= twoPI * floor(mph / twoPI);
	cph -= twoPI * floor(cph / twoPI);
	*/


	// int fpw = _controlfp(0, 0);
	// fpw = _controlfp(MCW_EM, MCW_EM);

	static int callcnt = 0;

// 	MainForm->Label6->Caption = String(callcnt) + String("in");


	//
	// Low-pass filter
	// Applied only if the sample rate exceeds the WFM bandwidth
	//

	static float xkm00_1 = 0.;
	static float ykm00_1 = 0.;
	static float xkm00_2 = 0.;
	static float ykm00_2 = 0.;
	static float xkm00_3 = 0.;
	static float ykm00_3 = 0.;
	static float xkm00_4 = 0.;
	static float ykm00_4 = 0.;
	static float xkm00_5 = 0.;
	static float ykm00_5 = 0.;

	static float xkm01_1 = 0.;
	static float xkm01_2 = 0.;
	static float xkm01_3 = 0.;
	static float xkm01_4 = 0.;
	static float ykm01_1 = 0.;
	static float ykm01_2 = 0.;
	static float ykm01_3 = 0.;
	static float ykm01_4 = 0.;

	if(Fs > MainForm->wfm_rf_cut)
	{

		float const g00 = 2.5e5 / float(Fs) / ((Fs > 1.e6) ? 2. : 1.);
		float const tau00 = 1. / (PI * MainForm->wfm_rf_cut);
		float const alpha00 = 1. / float(Fs * tau00 + 1.);


		SCplx *cptr00 = tmpSamp;
		for(k = 0; k < BUFSIZE; k++)
		{
			(*cptr00).re = xkm00_1 = ((*cptr00).re - xkm00_1) * alpha00 + xkm00_1;
			(*cptr00).im = ykm00_1 = ((*cptr00).im - ykm00_1) * alpha00 + ykm00_1;

			/**/
			(*cptr00).re = xkm00_2 = ((*cptr00).re - xkm00_2) * alpha00 + xkm00_2;
			(*cptr00).im = ykm00_2 = ((*cptr00).im - ykm00_2) * alpha00 + ykm00_2;

			(*cptr00).re = xkm00_3 = ((*cptr00).re - xkm00_3) * alpha00 + xkm00_3;
			(*cptr00).im = ykm00_3 = ((*cptr00).im - ykm00_3) * alpha00 + ykm00_3;
			/**/

			/**/
			(*cptr00).re = xkm00_4 = ((*cptr00).re - xkm00_4) * alpha00 + xkm00_4;
			(*cptr00).im = ykm00_4 = ((*cptr00).im - ykm00_4) * alpha00 + ykm00_4;

			(*cptr00).re = xkm00_5 = ((*cptr00).re - xkm00_5) * alpha00 + xkm00_5;
			(*cptr00).im = ykm00_5 = ((*cptr00).im - ykm00_5) * alpha00 + ykm00_5;
			/**/

			(*cptr00).re *= g00;    // Really necessary?
			(*cptr00).im *= g00;    // Really necessary?

			cptr00++;
		}
	}


	// Generating some test signals
	/*
	float const f1 = 1.e3;
	float const w1_samp = twoPI * f1 / float(Fs);
	static float cph = 0.;
	static float mph = 0.;
	for(k = 0; k < BUFSIZE; k++)
	{
		mph += w1_samp;
		cph += sin(mph) * w1_samp;
		tmpSamp[k].re = 0.1 * cos(cph);
		tmpSamp[k].im = 0.1 * sin(cph);
	}
	mph -= twoPI * floor(mph / twoPI);
	cph -= twoPI * floor(cph / twoPI);
	/**/


	// Demodulate
	int kstep_v = 1; // = int(log(MainForm->srateIn / float(MainForm->srateOut) / 1.5) / log(2.));
	if(Fs >= 2000000) kstep_v = 4;
	else if(Fs > 1000000) kstep_v = 2;
	else if(Fs > 500000) kstep_v = 1;
	else kstep_v = 1;
	int const kstep = kstep_v;

	SCplx *cptr = tmpSamp;

	float s_re, s_im;
	static float ts0_r = 0.;
	static float ts0_i = 0.;

	float const * const sin_t = MainForm->sin_t;
	float const * const sin_2t = MainForm->sin_2t;
	float const * const sin_3t = MainForm->sin_3t;
	float const * const cos_t = MainForm->sin_t + TRIG_FUNC_TAB_SIZE / 4;
	float const * const cos_2t = MainForm->sin_2t + TRIG_FUNC_TAB_SIZE / 8;
	float const * const cos_3t = MainForm->sin_3t + TRIG_FUNC_TAB_SIZE / 16;
	float const * const atan_t= MainForm->atan_t;

	cptr = tmpSamp;
	float prod_r, prod_i;
	static float rs0old = 0.;
	float const mul0 = float(ATAN_TAB_SIZE / 16);
	float const vol = atan(Fs / 5.e5) / 500.;
	float const l0 = 1.5083775;		// = atan(16.);
	float const lcoeff = 0.00130039; // (PIhalf - l0) / 48.;
	for(k = 0; k < BUFSIZE; k += kstep)
	{
		s_re = (*cptr).re;
		s_im = (*cptr).im;

		prod_r = s_re * ts0_r + s_im * ts0_i;
		prod_i = s_im * ts0_r - s_re * ts0_i;

		float atan_arg;
		if(prod_r)				       		// atan2 is fast enough for
		{									// low sample rates, but it is
			// rs0 = atan2(prod_i, prod_r); // too slow for higher rates

			/**/
			atan_arg = fabs(prod_i / prod_r);
			if(atan_arg >= 32.)   	// Saturate to PI/2
			{
				rs0 = PIhalf;
			}
			else if(atan_arg >= 16.)	// Linear interpolation
			{
				rs0 = l0 + (atan_arg - 16.) * lcoeff;
			}
			else
			{
				// atan_arg = min(16., atan_arg);
				// atan_arg = max(-16., atan_arg);
				rs0 = atan_t[int(mul0 * atan_arg)];
			}
			if(prod_r < 0.)
			{
				if(prod_i > 0.) rs0 = PI - rs0;
				else rs0 -= PI;
			}
			else if(prod_i < 0.)
				rs0 *= -1.;
			/**/
		}
		else rs0 = rs0old;
		rs0 *= vol;

		rs0old = rs0;

		ts0_r = s_re;
		ts0_i = s_im;

		(*cptr).re = rs0;
		(*cptr).im = 0.;

		cptr += kstep;
	}


	//
	// Stereo processing - BEGIN
	//
	float const fp = 19000.;		// Frequency of pilot [Hz]
	float const Fnorm = fp / float(Fs);
	float acc_re, acc_im;
	if(1) // MainForm->submode == both)
	{
		//
		// Detect the stereo pilot and
		// down-convert the stereo (L-R) component
		//
		acc_im = 0.;
		acc_re = 0.;
		cptr = tmpSamp;
		float const mul1 =  float(TRIG_FUNC_TAB_SIZE) / twoPI;
		float g1_inc = 0.;
		float s_re = 0.;
		float const g1 = kstep * twoPI * Fnorm * mul1;
		float ph_inc = phi;
		float ph_inc_x = phi * mul1;
		float const g0 =  kstep * fourPI * Fnorm;
		float const g0_x = kstep * fourPI * Fnorm * mul1;
#ifdef RDS_ENABLED
		float const g0_rds =  kstep * sixPI * Fnorm * mul1;
		float ph_inc_rds = rds_phi * mul1;
		SCplx *cptr_rds = rds_sample_buff + rds_sample_buff_idx;
#endif
		unsigned int vidx0, vidx1;

		float const tau01 = 1. / (PI * 3200. * float(kstep));
		float const alpha01 = 1. / float(Fs * tau01 + 1.);

		for(k = 0; k < BUFSIZE; k += kstep)
		{
			s_re = (*cptr).re;

			//
			// 19 kHz pilot phase estimation
			//
			vidx0 = short(g1_inc) & 0xffff;
			// acc_re += s_re * sin(g1_inc);
			// acc_im += s_re * cos(g1_inc);
			acc_re += s_re * sin_t[vidx0];
			acc_im += s_re * cos_t[vidx0];
			g1_inc += g1;

			//
			// Frequency conversion of the L-R component
			//
			vidx1 = short(ph_inc_x) & 0xffff;
			// (*cptr).im = s_re * 2. * sin(ph_inc);
			(*cptr).im = s_re * 2. * sin_t[vidx1];
			// ph_inc += g0;
			ph_inc_x += g0_x;

#ifdef RDS_ENABLED
			// Frequency conversion of the RDS component
			vidx1 = short(ph_inc_rds) & 0xffff;

			// DEBUG
			// Move RDS to baseband (real)
			// (*cptr).re = s_re * 2. * sin_t[vidx1];
			// (*cptr).re = xkm01_1 = ((*cptr).re - xkm01_1) * alpha01 + xkm01_1;
			// (*cptr).re = xkm01_2 = ((*cptr).re - xkm01_2) * alpha01 + xkm01_2;
			// (*cptr).re = xkm01_3 = ((*cptr).re - xkm01_3) * alpha01 + xkm01_3;
			// (*cptr).re = xkm01_4 = ((*cptr).re - xkm01_4) * alpha01 + xkm01_4;
			// DEBUG

			(*cptr_rds).re = s_re * sin_t[vidx1];
			(*cptr_rds).re = xkm01_1 = ((*cptr_rds).re - xkm01_1) * alpha01 + xkm01_1;
			(*cptr_rds).re = xkm01_2 = ((*cptr_rds).re - xkm01_2) * alpha01 + xkm01_2;
			(*cptr_rds).im = s_re * cos_t[vidx1];
			(*cptr_rds).im = ykm01_1 = ((*cptr_rds).im - ykm01_1) * alpha01 + ykm01_1;
			(*cptr_rds).im = ykm01_2 = ((*cptr_rds).im - ykm01_2) * alpha01 + ykm01_2;
			(*cptr).re = (*cptr_rds).re;
			cptr_rds++;     ////// DEBUG!!!!
			rds_sample_buff_idx++;
			if(rds_sample_buff_idx >= RDS_SAMPLE_BUFF_SIZE)
			{
				rds_sample_buff_idx = 0;
				cptr_rds = rds_sample_buff;
			}
			ph_inc_rds += g0_rds;
#endif

			cptr += kstep;
		}

#ifdef RDS_ENABLED
		WideFM_RDS_Process(rds_sample_buff, rds_sample_buff_idx, Fs/kstep);
#endif

		//
		// Update estimate of the pilot subcarrier phase
		// phi = 2. * atan2(acc_im, acc_re);
		ph_inc += float(BUFSIZE) * Fnorm * fourPI;
		ph_inc -= fourPI * floor(ph_inc / fourPI);
		float np;
		if(acc_re != 0.)
			np =  atan2(acc_im, acc_re);
			// np =  atan_t[int(TRIG_FUNC_TAB_SIZE * acc_im / acc_re / PIquart)];
		else
			np = 0.;
		if(np < 0.) np += twoPI;
		np += float(BUFSIZE) * twoPI * Fnorm;
		np -= twoPI * floor(np / twoPI);
		ph_inc /= 2.;
		if(abs(np - ph_inc) > PI)
		{
			if(np < ph_inc) np += twoPI;
			else ph_inc += twoPI;
		}

		// We average the current (new) phase estimation
		// np with the past estimation ph_inc.
		// Now tmpSamp[].im holds the L-R signal or nothing
		// if the stereo pilot was not detected
		phi = 1.75 * ph_inc + .25 * np;
#ifdef RDS_ENABLED
		rds_phi = (3. * phi) / 2.;
		if(rds_phi >= twoPI) rds_phi -= twoPI;
#endif
	}   // if(MainForm->submode == both && Fs >= 250000)
	//
	// Stereo processing - END
	//

	// De-emphasis filters
	float const tau = MainForm->wfm_deemph_tau;
	float const alpha = 1. / float(Fs / float(kstep) * tau + 1.);
	cptr = tmpSamp;
	for(k = 0; k < BUFSIZE; k += kstep)
	{
		(*cptr).re = xkm1 = ((*cptr).re - xkm1) * alpha + xkm1;
		(*cptr).im = ykm1 = ((*cptr).im - ykm1) * alpha + ykm1;
		cptr += kstep;
	}

	// Inject here some test signals
	/* float const m = 5.e3 / float(MainForm->srateIn) * twoPI;
	static float phy = 0.;
	SCplx *tmptr = tmpSamp;
	for(k = 0; k < BUFSIZE; k++)
	{
		(*tmptr).re = 0.01 * cos(phy);
		(*tmptr).im = -(*tmptr).re;
		tmptr++;
		phy += m;
	}
	phy -= twoPI * floor(phy / twoPI); */



	// MainForm->Label6->Caption = String(callcnt++) + String("out");


	return;

} // if(MainForm->mode == FM && MainForm->submode != lower)




//
// Wide FM: post-decimation processing
//
void __fastcall TProcessIn::WideFM_PostDecProc(SCplx *FF1fsamp,
				float *FF2audio, float *FF2audioStereo)
{

	// int const f_t1 = 20.;
	int const Fa = MainForm->srateOut;
	// int const f_t1_samp = (AFFTLEN * f_t1) / Fa;

	float const f_t = MIN(MainForm->wfm_audio_cut, Fa / 2);
	int const f_t_samp = AFFTLEN * f_t / float(Fa);

	register int k;

	static int const direct  = NSP_Forw | NSP_NoBitRev;
	static int const inverse = NSP_Inv  | NSP_NoBitRev;
	static int const order = (int)(log(AFFTLEN + 1)/log(2.));

	static int loop2ctr = 0;


	static int callcnt = 0;




	SCplx *cptr = FF1fsamp;
	SCplx *cptr1 = FF1fsamp + AFFTLEN;


	// Low-pass filter (smoothed)
#define FIL0_TR_WID_LP	16
	float const g = 100.; //float(AFFTLEN) / float(2. * (f_t_samp - f_t1_samp));
	for(k = 0; k < f_t_samp - FIL0_TR_WID_LP/2; k++)
	{
		(*cptr).re *= g;
		(*cptr).im *= g;
		cptr++;
		(*cptr1).re *= g;
		(*cptr1).im *= g;
		cptr1--;
	}
	float g1 ; // = g - g / float(FIL0_TR_WID_LP);
	for(; k < f_t_samp + FIL0_TR_WID_LP / 2; k++)
	{
		g1 = g * .5 * (1 + cos(PI * (k - (f_t_samp - FIL0_TR_WID_LP/2)) / float(FIL0_TR_WID_LP)));
		(*cptr).re *= g1;
		(*cptr).im *= g1;
		cptr++;
		(*cptr1).re *= g1;
		(*cptr1).im *= g1;
		cptr1--;
		// g1 -= g / float(FIL_TR_WID);
	}
	for(; k < AFFTLEN / 2 ; k++)
	{
		(*cptr).re = (*cptr).im = 0.;
		cptr++;
		(*cptr1).re = (*cptr1).im = 0.;
		cptr1--;
	}


	const int len = (AFFTLEN - BUFSIZE)/2;
	SCplx const *tptr_FF1fsamp = FF1fsamp + len;
	float *tptr_FF2audio = FF2audio;
	float *tptr_FF2audioStereo = FF2audioStereo;

	nspcFft(FF1fsamp, order, inverse);           // inverse complex FFT


	for(k = 0; k<BUFSIZE; k++ )           // AlpAdd:
	{                                    // AlpAdd:
		*tptr_FF2audio++ = (*tptr_FF1fsamp).re;
		*tptr_FF2audioStereo++ = (*tptr_FF1fsamp++).im;
	}




	// Pass data to GUI process and request screen update
	EnterCriticalSection(&MainForm->acFF2que);
	memmove(MainForm->PFF2->PolyQue, MainForm->PFF2->PolyQue + BUFSIZE,
			 (MainForm->ff2Size * MainForm->polyfactor - BUFSIZE) * sizeof(float));
	memcpy(MainForm->PFF2->PolyQue + (MainForm->polyfactor * MainForm->ff2Size - BUFSIZE),
				FF2audio, BUFSIZE * sizeof(float));
	LeaveCriticalSection(&MainForm->acFF2que);



	if((loop2ctr++ % (21 - MainForm->WF2Speed->Position)) == 0)
		SetEvent(MainForm->FF2BufferReady);  // compute a new FF2 screen, by
										   // awakening ProcessFF2, which then
										   // will call ComputeFF2
	
	/*
	float FF2temp[BUFSIZE];
	nspsbAbs2(FF2audio, FF2temp, BUFSIZE);
	float const *tptr_FF2temp = FF2temp;
	float *tptr_au = FF2audio;
	float *tptr_aus = FF2audioStereo;
	float fact;
	float const c1 = 0.01;
	float tmp;
	static float ss = 0.;
	static float pk = 0.;
	static float pk2 = 0.;
	if(MainForm->agc != off)
	{
		for (k = 0; k < BUFSIZE; k++)
		{
			tmp = *tptr_FF2temp++;

			if(ss < tmp)
			{ // ss = (9. * ss + tmp) / 10.;    // slow down attack time
				ss += 0.1 * (tmp - ss);
			  pk = tmp;
			  hangcnt = (MainForm->agc == fast) ? 1 : 6;
			}

			// float fact = 0.9 / max(ss, MainForm->agcthr);
			fact = c1 / max(ss, MainForm->agcthr);
			// *tptr_au++ *= fact;
			// *tptr_aus++ *= fact;  // AlpAdd
			if(!hangcnt) ss  *= MainForm->agc_decay;

			pk  *= MainForm->agc_decay;
		}
	}
	else
	{
		for (k = 0; k < BUFSIZE; k++)
		{
			tmp = *tptr_FF2temp++;

			if(ss < tmp)
			{ // ss = (9. * ss + tmp) / 10.;    // slow down attack time
				ss += 0.1 * (tmp - ss);
			  pk = tmp;
			  hangcnt = (MainForm->agc == fast) ? 1 : 6;
			}

			fact = 3.e3 * MainForm->agcgain;
			// *tptr_au++ *= fact;
			// *tptr_aus++ *= fact;     //AlpAdd
			if(!hangcnt) ss  *= MainForm->agc_decay;

			pk  *= MainForm->agc_decay;
		}
	}


	if(hangcnt > 0)  hangcnt--;
	MainForm->pklevel = pk;
	*/


	// Synchronize(&UpdateVU);

	// MainForm->WideBandDenoiser(FF2audio);


	float const vol = (MainForm->audiomute) ? 0. :  (MainForm->vol * MainForm->vol) / (99. * 99.);

	float const denorm = vol * 3. * twoTO23m1 * (MainForm->nr ? 1.5 : 1.) / ONEFIFTH;

	nspsbMpy1(denorm, FF2audio , BUFSIZE);		// denormalize...
	nspsbMpy1(denorm, FF2audioStereo, BUFSIZE);	// AlpAdd: denormalize...


	/* nspsbAbs2(FF2audio, FF2temp, BUFSIZE);
	float peakvol = nspsMax(FF2temp, BUFSIZE);
	bool over;
	if(peakvol > 0.995 * twoTO23m1)
	{
		// nspsbMpy1((0.99 * twoTO23m1) / peakvol, FF2audio , BUFSIZE);
		// nspsbMpy1((0.99 * twoTO23m1) / peakvol, FF2audioStereo, BUFSIZE); // AlpAdd: denormalize...
		over = true;
	}
	else over = false;

	MainForm->overload = over;
	*/


	return;
}



//
// Wide FM: post-decimation processing - first part
//
void __fastcall TProcessIn::WideFM_PostDecProc_1(SCplx *FF1fsamp,
				float *FF2audio, float *FF2audioStereo)
{

	// int const f_t1 = 20.;
	int const Fa = MainForm->srateOut;
	// int const f_t1_samp = (AFFTLEN * f_t1) / Fa;

	float const f_t = MIN(MainForm->wfm_audio_cut, Fa / 2);
	int const f_t_samp = AFFTLEN * f_t / float(Fa);

	register int k;

	static int const direct  = NSP_Forw | NSP_NoBitRev;
	static int const inverse = NSP_Inv  | NSP_NoBitRev;
	static int const order = (int)(log(AFFTLEN + 1)/log(2.));

	static int loop2ctr = 0;


	static int callcnt = 0;




	SCplx *cptr = FF1fsamp;
	SCplx *cptr1 = FF1fsamp + AFFTLEN;



	// Low-pass filter (smoothed)
#define FIL0_TR_WID_LP	16
	float const g = 100.; //float(AFFTLEN) / float(2. * (f_t_samp - f_t1_samp));
	for(k = 0; k < f_t_samp - FIL0_TR_WID_LP/2; k++)
	{
		(*cptr).re *= g;
		(*cptr).im *= g;
		cptr++;
		(*cptr1).re *= g;
		(*cptr1).im *= g;
		cptr1--;
	}
	float g1 ; // = g - g / float(FIL0_TR_WID_LP);
	for(; k < f_t_samp + FIL0_TR_WID_LP / 2; k++)
	{
		g1 = g * .5 * (1 + cos(PI * (k - (f_t_samp - FIL0_TR_WID_LP/2)) / float(FIL0_TR_WID_LP)));
		(*cptr).re *= g1;
		(*cptr).im *= g1;
		cptr++;
		(*cptr1).re *= g1;
		(*cptr1).im *= g1;
		cptr1--;
		// g1 -= g / float(FIL_TR_WID);
	}
	for(; k < AFFTLEN / 2 ; k++)
	{
		(*cptr).re = (*cptr).im = 0.;
		cptr++;
		(*cptr1).re = (*cptr1).im = 0.;
		cptr1--;
	}

	nspcFft(FF1fsamp, order, inverse);           // inverse complex FFT


	/**/
	const int len = (AFFTLEN - BUFSIZE)/2;
	SCplx const *tptr_FF1fsamp = FF1fsamp + len;
	float *tptr_FF2audio = FF2audio;
	float *tptr_FF2audioStereo = FF2audioStereo;

	for(k = 0; k<BUFSIZE; k++ )
	{
		*tptr_FF2audio++ = (*tptr_FF1fsamp).re;
		*tptr_FF2audioStereo++ = (*tptr_FF1fsamp++).im;
	}
	/**/


	// Pass data to GUI process and request screen update
	/*
	EnterCriticalSection(&MainForm->acFF2que);
	memmove(MainForm->PFF2->PolyQue, MainForm->PFF2->PolyQue + BUFSIZE,
			 (MainForm->ff2Size * MainForm->polyfactor - BUFSIZE) * sizeof(float));
	memcpy(MainForm->PFF2->PolyQue + (MainForm->polyfactor * MainForm->ff2Size - BUFSIZE),
				FF2audio, BUFSIZE * sizeof(float));
	LeaveCriticalSection(&MainForm->acFF2que);

	if((loop2ctr++ % (21 - MainForm->WF2Speed->Position)) == 0)
		SetEvent(MainForm->FF2BufferReady);  // compute a new FF2 screen, by
	/**/

	return;
}





void __fastcall TProcessIn::WideFM_PostDecProc_2(SCplx *FF1fsamp,
				float *FF2audio, float *FF2audioStereo)
{
	// int const f_t1 = 20.;
	int const Fa = MainForm->srateOut;
	// int const f_t1_samp = (AFFTLEN * f_t1) / Fa;

	float const f_t = MIN(MainForm->wfm_audio_cut, Fa / 2);
	int const f_t_samp = AFFTLEN * f_t / float(Fa);

	register int k;

	static int const direct  = NSP_Forw | NSP_NoBitRev;
	static int const inverse = NSP_Inv  | NSP_NoBitRev;
	static int const order = (int)(log(AFFTLEN + 1)/log(2.));

	static int loop2ctr = 0;


	static int callcnt = 0;

	const int len = (AFFTLEN - BUFSIZE)/2;
	SCplx const *tptr_FF1fsamp = FF1fsamp + len;
	float *tptr_FF2audio = FF2audio;
	float *tptr_FF2audioStereo = FF2audioStereo;

	/*
	for(k = 0; k<BUFSIZE; k++ )           // AlpAdd:
	{                                    // AlpAdd:
		*tptr_FF2audio++ = (*tptr_FF1fsamp).re;
		*tptr_FF2audioStereo++ = (*tptr_FF1fsamp++).im;
	}
	*/



	// Pass data to GUI process and request screen update
	/**/
	EnterCriticalSection(&MainForm->acFF2que);
	memmove(MainForm->PFF2->PolyQue, MainForm->PFF2->PolyQue + BUFSIZE,
			 (MainForm->ff2Size * MainForm->polyfactor - BUFSIZE) * sizeof(float));
	memcpy(MainForm->PFF2->PolyQue + (MainForm->polyfactor * MainForm->ff2Size - BUFSIZE),
				FF2audio, BUFSIZE * sizeof(float));
	LeaveCriticalSection(&MainForm->acFF2que);

	if((loop2ctr++ % (21 - MainForm->WF2Speed->Position)) == 0)
		SetEvent(MainForm->FF2BufferReady);  // compute a new FF2 screen, by
										   // awakening ProcessFF2, which then
										   // will call ComputeFF2
	/**/

	float const vol = (MainForm->audiomute) ? 0. :  (MainForm->vol * MainForm->vol) / (99. * 99.);

	float const denorm = vol * 3. * twoTO23m1 * (MainForm->nr ? 1.5 : 1.) / ONEFIFTH;

	nspsbMpy1(denorm, FF2audio , BUFSIZE);		// denormalize...
	nspsbMpy1(denorm, FF2audioStereo, BUFSIZE);	// AlpAdd: denormalize...


	return;
}


#define RDS_SLOW_BUFFER_SIZE	16384
#define TDL_SIZE	32

void __fastcall TProcessIn::WideFM_RDS_Process(SCplx *rds_sample_buff, int idx1, int Fs0)
{
	static char firstime = 1;
	static int prev_idx = 0;
	float const mfil_h[] = {-.00853, -.0162, -.0159, 0., .0374,
							0.097, 0.172, 0.25, 0.31, .34,
							.32, .25, .137}; // We store h0[-13] to h0[1]. h0[0] = 0 are not stored

	static float rds_slow_buffer[RDS_SLOW_BUFFER_SIZE];	// Downsampled signal
	static int rds_slow_buffer_idx = 0;

	static float rds_matched[RDS_SLOW_BUFFER_SIZE];		// Output of matched filter
	static int rds_matched_idx = 0;

	static float tdl[TDL_SIZE];
	static int tdl_idx = 0;
	static FILE *fprds, *fprdscalls;


	// The input sample rate is Fs0 samples/second, which
	// is expected to be >= 250000 (and possibly < 500000)
	// Decimation of an integer factor <decimation> is performed
	// in order to obtain a sample stream of approximately 19kS/s.
	// This way, approx. 16 samples per RDS symbol are provided
	// to the following RS receiver stages through <rds_slow_buffer>.

	const int decimation = int(.5 + Fs0 / 19000.);
	static int decim_cnt = 0;

	// First call to this function:
	// generate filter impulse response
	if(firstime)
	{
		firstime = 0;	// Don' t get back here
		fclose(fopen("rds_stream.dat" , "wb"));
		fclose(fopen("rds_calls.txt" , "w"));
	}

	// fprdscalls = fopen("rds_calls.txt" , "a");
	// fprintf(fprdscalls, "Call: %7d, %7d, %7d\n", prev_idx, idx1, Fs0);
	// fclose(fprdscalls);


	if(idx1 != prev_idx) return;
	fprds = fopen("rds_stream.dat" , "ab");
	fwrite(rds_sample_buff, sizeof(SCplx), RDS_SAMPLE_BUFF_SIZE, fprds);
	fclose(fprds);
	return;


	// Low-pass filter (2.4 kHz BW)
	float const tau = 1. / (twoPI * 2400.);
	float const alpha = 1. / float(Fs0 * tau + 1.);
	float xkm[] = {0., 0., 0., 0., 0., 0., 0., 0., 0., 0.};

	float *iptr = 0; // rds_sample_buff + prev_idx;
	//SCplx *optr = rds_slow_buffer + rds_slow_buffer_idx;
	for(int k = prev_idx; k != idx1; k++)
	{
		k = idx1 - 1;
		if(k >= RDS_SAMPLE_BUFF_SIZE)
		{

			// Write to file
			/*
			fprds = fopen("rds_matched.txt" , "w");
			for(int a = 0; a < RDS_SAMPLE_BUFF_SIZE/8; a++)
			{
				fprintf(fprds, "%9.3f\n", rds_sample_buff[a] * 1.e3);
			}
			fclose(fprds);
			exit(1);
			*/
			k = 0;
			iptr = 0; //rds_sample_buff;
		}
		continue;

		xkm[0] = (*iptr - xkm[0]) * alpha + xkm[0];
		xkm[1] = (xkm[0] - xkm[1]) * alpha + xkm[1];
		xkm[2] = (xkm[1] - xkm[2]) * alpha + xkm[2];
		xkm[3] = (xkm[2] - xkm[3]) * alpha + xkm[3];

		if(0) //!decim_cnt++)
		{
			// Write sample to TDL
			tdl[tdl_idx] = xkm[3];

			// Compute matched filter output
			float mfout = 0.;
			for(int c = 0; c < 13; c++)
			{
				mfout += mfil_h[c] *
					(tdl[(tdl_idx - c + TDL_SIZE) % TDL_SIZE] +
					 tdl[(tdl_idx - 26 + c + TDL_SIZE) % TDL_SIZE]);
			}
			// *optr = mfout;

			fprintf(fprds, " %8.2f", mfout);

			tdl_idx++;
			tdl_idx %= TDL_SIZE;

			// Update slow buffer pointer and index
			//optr++;
			rds_slow_buffer_idx++;
			if(rds_slow_buffer_idx >= RDS_SLOW_BUFFER_SIZE)
			{
				rds_slow_buffer_idx = 0;
				//optr = rds_slow_buffer;
			}
		}
		decim_cnt %= decimation;
		iptr++;
	}
 pr_end:
	// fclose(fprds);

	prev_idx = idx1;
	return;
}

