//---------------------------------------------------------------------------
#include <vcl.h>
#include "pch.h"
#pragma  hdrstop

#include "do_peak.h"

static double a1 = 0., a2 = 0., b0 = 0.;
//---------------------------------------------------------------------------
void __fastcall TMainForm::do_peak(void)
{
   static double y0, y1=0., y2=0., x0;

// risuonatore IIR con due zeri nell'origine e due poli in wr e -wr
   for (int k = 0; k < bufsize; k++)
   {  x0 = X[k];
      y0 = -a1 * y1 - a2 * y2 + b0 * x0;
      y2 = y1;
      y1 = y0;
      X[k] = y0;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::compute_IIR_parms(void)
{
   double r = 0.993, r2, wr, cosw0, corr;

   a1 = a2 = b0 = 0.;  // nel caso di esecuzione parallela con il thread
   r2 = r*r;
   wr = 2 * pkF / rate * PI;
   corr = PI - wr; // correzione empirica verificata con Matlab per il guadagno
   cosw0 = (2 * r / (1 + r2)) * cos(wr); // correzione per la freq. di risonanza

   a1 = -2. * r * cosw0;
   a2 = r2;
// il coefficiente b0 e' normalizzato per gain = 0 dB su tutta la gamma
   b0 = corr * (1. - r) * sqrt(1. + r2 - 2 * r * cosw0);

}
