//---------------------------------------------------------------------------
// Here there are the implementations of some simple classes used throughout Winrad
//---------------------------------------------------------------------------
#include <vcl.h>
#include "pch.h"
#pragma  hdrstop

#include "MyClasses.h"
#include "main.h"

bool TNCODigits::negative = false;
//---------------------------------------------------------------------------
void TLog::OpenLog()
{
   f = fopen("digiradio.log", "wt");
}
//---------------------------------------------------------------------------
void TLog::WriteLog(char *s, int v)
{
   struct  time t;
   char    ora[128], str[1024];

   if(!f) return;
   gettime(&t);
   sprintf(ora, "%2d:%02d:%02d.%02d", t.ti_hour, t.ti_min, t.ti_sec, t.ti_hund);
   sprintf(str, "Time = %s => %s  value = %d\n", ora, s, v);
   fputs(str, f);
   fflush(f);
}
//---------------------------------------------------------------------------
void TLog::WriteMag(float m1, float m2)
{
   char str[1024];

   if(!f) return;
	 sprintf(str, "%5.1f   %5.1f\t   |\n", m1, m2);
   fputs(str, f);
   fflush(f);
}
//---------------------------------------------------------------------------
void TLog::WriteTime(char *s, float elapsed)
{
   char str[1024];

   if(!f) return;
   sprintf(str, s, elapsed);
   fputs(str, f);
   fflush(f);
}
//---------------------------------------------------------------------------
void TLog::WriteIQ(SCplx IQ)
{
   char str[128];

   if(!f) return;
   sprintf(str, "%16.8f%16.8f", IQ.re, IQ.im);
   fputs(str, f);
   fflush(f);
}
//---------------------------------------------------------------------------
void TLog::WriteFloat(float val)
{
   char str[128];

   if(!f) return;
   sprintf(str, "%16.8f", val);
   fputs(str, f);
   fflush(f);
}
//---------------------------------------------------------------------------
__fastcall TDnSample::TDnSample() : idx(3.), fac(1.), idxint(-1),
									tmp(new SCplx[4096])
{
   ZeroMemory(tmp, 4096 * sizeof(SCplx));
}
//---------------------------------------------------------------------------
__fastcall TDnSample::~TDnSample()
{
   delete[] tmp;
}
//---------------------------------------------------------------------------
void __fastcall TDnSample::setDnfactor(float factor)
{
   fac  = factor;
}
//---------------------------------------------------------------------------
// The windowed sync resampler
//---------------------------------------------------------------------------
int __fastcall TDnSample::dnsample(SCplx *in, SCplx *out, int len)
{
   int k;

   memcpy(tmp + 7, in, len * sizeof(SCplx));
   cnt = 0;
   if(idxint != -1) idx -= len;

   while(idxint = (int)idx, idxint < len + 3)
   {
	 float re, im;

	 sincidx = (int)(SINCLEN/2 - (idx - idxint)*SINCSTEP + 0.5);
	 re = tmp[idxint - 3].re * MainForm->sinc[sincidx - 3*SINCSTEP];
	 re+= tmp[idxint - 2].re * MainForm->sinc[sincidx - 2*SINCSTEP];
	 re+= tmp[idxint - 1].re * MainForm->sinc[sincidx - 1*SINCSTEP];
	 re+= tmp[idxint].re * MainForm->sinc[sincidx];
	 re+= tmp[idxint + 1].re * MainForm->sinc[sincidx + 1*SINCSTEP];
	 re+= tmp[idxint + 2].re * MainForm->sinc[sincidx + 2*SINCSTEP];
	 re+= tmp[idxint + 3].re * MainForm->sinc[sincidx + 3*SINCSTEP];
	 re+= tmp[idxint + 4].re * MainForm->sinc[sincidx + 4*SINCSTEP];

	 im = tmp[idxint - 3].im * MainForm->sinc[sincidx - 3*SINCSTEP];
	 im+= tmp[idxint - 2].im * MainForm->sinc[sincidx - 2*SINCSTEP];
	 im+= tmp[idxint - 1].im * MainForm->sinc[sincidx - 1*SINCSTEP];
	 im+= tmp[idxint].im * MainForm->sinc[sincidx];
	 im+= tmp[idxint + 1].im * MainForm->sinc[sincidx + 1*SINCSTEP];
	 im+= tmp[idxint + 2].im * MainForm->sinc[sincidx + 2*SINCSTEP];
	 im+= tmp[idxint + 3].im * MainForm->sinc[sincidx + 3*SINCSTEP];
	 im+= tmp[idxint + 4].im * MainForm->sinc[sincidx + 4*SINCSTEP];


	 (*out).re = re;   (*out++).im = im;
	 idx += fac;
	 cnt++;
   }

   for(k = 0; k < 7; k++)
   {
	 tmp[k].re = tmp[len + k].re;    tmp[k].im = tmp[len + k].im;
   }

   return cnt;
}
//---------------------------------------------------------------------------
void __fastcall TExtLoDigits::Init(int k)
{
    idx = k;
    value = 0;
    bright = false;
}
//---------------------------------------------------------------------------
void __fastcall TExtLoDigits::SetVal(int k)
{
    value = k;
}
//---------------------------------------------------------------------------
bool __fastcall TExtLoDigits::Inc(void)
{
    bool ok = true;

    if(++value > 9)
    {
      if(idx == 0)
      {
        value = 9;
        return false;
      }

	  if(MainForm->ExtLoDigit[idx - 1].Inc())
        value = 0, ok = true;
      else
        value = 9, ok = false;;
    }
    Show(MainForm->ExtLoDig[idx]);
	return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TExtLoDigits::Dec(void)
{
    bool ok = true;

    if(--value < 0)
    {
      if(idx == 0)
      {
        value = 0;
        return false;
      }

      if(MainForm->ExtLoDigit[idx - 1].Dec())
        value = 9, ok = true;
      else
        value = 0, ok = false;
    }
    Show(MainForm->ExtLoDig[idx]);
    return ok;
}
//---------------------------------------------------------------------------
void __fastcall TExtLoDigits::Show(TImage* img)
{
    MainForm->DigList->GetBitmap(bright ? value+10 : value, img->Picture->Bitmap);
    img->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TNCODigits::Init(int k)
{
    idx = k;
    value = 0;
    bright = false;
}
//---------------------------------------------------------------------------
void __fastcall TNCODigits::SetVal(int k)
{
    if(k < 0) negative = true;
    value = abs(k);
}
//---------------------------------------------------------------------------
bool __fastcall TNCODigits::Inc(void)
{
    bool ok = true;

    if(++value > 9)
    {
      if(idx == 0)
      {
        value = 9;
        return false;
      }

      if(MainForm->NCODigit[idx - 1].Inc())
        value = 0, ok = true;
      else
        value = 9, ok = false;;
    }
    Show(MainForm->NCODig[idx]);
    return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TNCODigits::Dec(void)
{
    bool ok = true;

    if(--value < 0)
    {
      if(idx == 0)
	  {
        value = 0;
        return false;
      }

      if(MainForm->NCODigit[idx - 1].Dec())
        value = 9, ok = true;
      else
        value = 0, ok = false;
    }
    Show(MainForm->NCODig[idx]);
    return ok;
}
//---------------------------------------------------------------------------
void __fastcall TNCODigits::Show(TImage* img)
{
    if(idx == 0 && negative) MainForm->DigList->GetBitmap(20, img->Picture->Bitmap); // 20 == "-"
    else
      MainForm->DigList->GetBitmap(bright ? value+10 : value, img->Picture->Bitmap);

    img->Repaint();

}
//---------------------------------------------------------------------------

#pragma package(smart_init)
